#include<iostream.h>
#include<conio.h>

#include<allegro.h>

// le but est d'afficher une carte a jouer a partir d'un fichier bmp


struct carte {
	char couleur;	// 'c'=coeur, 'k'=carreau, 't'=trefle, 'p'=pique
	int  valeur;	// 1,2, ... nb_cartes_par_couleur
	};

const int largeur_carte = 70;   //
const int hauteur_carte = 100;  //
const int bord_x = 160; // passage d'un ecran 320 x 200  a un ecran 640 x 480
const int bord_y = 100; // idem

///////////////////// prototype des fonctions

void affiche_carte_graphique(BITMAP * bmp_carte,carte une_carte,int x,int y);
void affiche_carte_verso(BITMAP *bmp_dos_carte, int x, int y);

/////////////////////// main
void main(void) {
 allegro_init();

 carte c[4];

 BITMAP * bmp_dos_carte;
 BITMAP * bmp_carte;
 RGB palette[256], palette_dos[256];

 int coul_fond;

                              // saisie 4 cartes
 for (int i=0; i<=3; i++) {
   cout << "Entrez une carte : valeur dans [1,13], et couleur (p,c,k,t)";
   cin >> c[i].valeur;
   cin >> c[i].couleur;
   cout << endl;
 }

// utiliser  set_gfx_mode(GFX_VGA,320,200,0,0) ds les salles 5 et 7

 if (set_gfx_mode(GFX_S3,640,480,0,0) != 0) {
    cout << "erreur lors du passage en mode graphique driver S3" << endl;
    exit(-1);
 }

 bmp_dos_carte = load_bitmap("z:\\algo\\images\\CarteDos.bmp",palette_dos);
 bmp_carte = load_bitmap("z:\\algo\\images\\Cartes.bmp",palette);

 if (bmp_dos_carte == 0 || bmp_carte == 0) {       // test si erreur
    cout << "erreur lors du chargement du fichier CarteDos.bmp";
    cout << " ou Cartes.bmp" << endl;
    exit (-1);
 }
 set_palette(palette);
                                      // trace le tapis du jeu
 coul_fond = getpixel(bmp_carte,1,1);
 rectfill (screen,bord_x + 0,bord_y + 0,bord_x + 319,bord_y + 199,coul_fond);


 affiche_carte_graphique(bmp_carte,c[0],bord_x + 0,bord_y + 99);
 affiche_carte_graphique(bmp_carte,c[1],bord_x + 80,bord_y + 10);
 affiche_carte_graphique(bmp_carte,c[2],bord_x + 170,bord_y + 10);
 affiche_carte_graphique(bmp_carte,c[3],bord_x + 249,bord_y + 99);

 getch();
// set_palette(palette_dos);
 affiche_carte_verso(bmp_dos_carte, bord_x + 0,bord_y + 99);
 getch();

 // detruire le bitmap bmp_dos_carte
 // mais comment ???

 allegro_exit();
}

/////////////// Definitions des fonctions /////////////////////:

void affiche_carte_graphique(BITMAP * bmp_carte,carte cart,int x,int y){
 int x_src,y_src;
 // dans le fichier bmp, les cartes sont rangees comme suit :
 // 4 lignes : As, 2, ... 10, V, D, R
 // Pique, trefle, carreau, coeur
 switch (cart.couleur) {
    case 'p' : y_src = 0; break;
    case 't' : y_src = hauteur_carte; break;
    case 'k' : y_src = 2*hauteur_carte; break;
    case 'c' : y_src = 3*hauteur_carte; break;
 }
 x_src = (cart.valeur -1) * largeur_carte;
 blit(bmp_carte, screen, x_src, y_src, x, y, largeur_carte, hauteur_carte);
}

void affiche_carte_verso(BITMAP * dos_carte, int x, int y) {
 blit(dos_carte, screen, 0,0,x,y,largeur_carte, hauteur_carte);
}
